<template>
  <section
    v-if="data.sections && data.sections.length"
    class="c-role-required-desired c-form-section"
  >
    <Title :text="data.desired_for_this_role_title" type="secondary" />

    <section
      v-for="(item, index) in data.sections"
      :key="index"
      class="c-role-required-desired__section"
    >
      <FormCondition
        :id="`${index}-desired`"
        :title="item.section_button_text"
        v-model="
          fields.desiredForThisRoleSections.$each[index].condition.$model
        "
        :error="
          formErrorMessagesHandler(
            fields.desiredForThisRoleSections.$each[index].condition
          )
        "
      />
      <div
        v-if="
          fields.desiredForThisRoleSections.$each[index].condition.$model ===
            'yes'
        "
      >
        <Paragraph
          v-for="(paragraph, paragraphIndex) in item.section_description"
          :key="`${index}-${paragraphIndex}`"
          :text="paragraph.section_description_text"
        />
        <section class="c-role-required-desired__list">
          <div
            v-for="role in fields.desiredForThisRoleRoles.$each.$iter"
            :key="role.id.$model"
            :class="[
              role.section_id.$model === index && !isPreview
                ? 'c-form-section'
                : ''
            ]"
          >
            <div
              v-if="role.section_id.$model === index"
              :class="[isPreview ? 'c-preview-box' : '']"
            >
              <ErrorMessage
                v-if="errors.id === index"
                :text="errors.sectionMinLength"
                align="right"
                class="min-row"
              />
              <div class="c-role-select-wrapper">
                <FormSelect
                  :id="`${role.id.$model}-role`"
                  v-model="role.role.$model"
                  :options="getPositions"
                  label="Role"
                  :error="formErrorMessagesHandler(role.role)"
                  noOptionsMessage="Please add some position in Your current & historic roles section"
                />
                <FormButtonRemove
                  @clicked="removeRoleHandler(role.id.$model, index)"
                  type="secondary"
                />
              </div>
              <FormTextarea
                :id="`${role.id.$model}-details`"
                v-model.trim="role.details.$model"
                :error="formErrorMessagesHandler(role.details)"
              />
            </div>
          </div>
        </section>
        <FormAddRole
          text="Add another role/row"
          @clicked="addRoleHandler(index)"
        />
      </div>
    </section>
  </section>
</template>

<script>
import { uuid } from "vue-uuid";
import { mapMutations } from "vuex";
import Title from "../ui/Title";
import { errorMixins } from "../mixins/formErrors";
import FormCondition from "../ui/form/FormCondition";
import FormAddRole from "../ui/form/FormAddRole";
import FormButtonRemove from "../ui/form/FormButtonRemove";
import Paragraph from "../ui/Paragraph";
import FormTextarea from "../ui/form/FormTextarea";
import FormSelect from "../ui/form/FormSelect";
import ErrorMessage from "../ui/ErrorMessage";
import { isPreviewMixin } from "../mixins/isPreview";

export default {
  name: "RoleDesired",
  components: {
    ErrorMessage,
    FormSelect,
    FormTextarea,
    FormCondition,
    Paragraph,
    FormButtonRemove,
    FormAddRole,
    Title
  },
  props: {
    fields: {
      type: Object,
      required: true
    }
  },
  mixins: [errorMixins, isPreviewMixin],
  data: function() {
    return {
      data: this.$store.state.data.data.desired_for_this_role,
      errors: {
        id: "",
        sectionMinLength: ""
      }
    };
  },
  computed: {
    getPositions() {
      return this.$store.state.form.currentHistoricRolesList
        .map(({ position }) => position)
        .filter(item => item)
        .map(item => item);
    }
  },
  methods: {
    ...mapMutations(["addRole", "removeRole"]),
    addRoleHandler(sectionId) {
      this.$store.commit("addRole", {
        field: "desiredForThisRoleRoles",
        data: {
          section_id: sectionId,
          id: uuid.v1(),
          role: "",
          details: ""
        }
      });
    },
    removeRoleHandler(id, sectionId) {
      const filteredBySectionId = this.$store.state.form.desiredForThisRoleRoles.filter(
        item => item.section_id === sectionId
      );

      if (filteredBySectionId.length === 1) {
        this.errors.id = sectionId;
        this.errors.sectionMinLength = "Required at least 1 row";
        setTimeout(() => {
          this.errors.id = "";
          this.errors.sectionMinLength = "";
        }, 1500);
      } else {
        this.$store.commit("removeRole", {
          field: "desiredForThisRoleRoles",
          id
        });
      }
    }
  }
};
</script>

<style lang="scss"></style>
